/* --------------------------------------------------------------------
 * Clac - calculator (C) 1994-2006 by Eero Tamminen.
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms specified in the COPYRIGHTS file.
 * 
 * Code for complex number calculations
 * --------------------------------------------------------------------
 */

#ifndef COMPLEX_H
#define COMPLEX_H

enum cord_type { RECT, POLAR };

typedef struct {      /* define complex number    */
  double real;        /* real part / lenght       */
  double imag;        /* imaginary part / heading */
} cplx;

#define ERR_TYPE  21  /* wrong type        */
#define ERR_DERO  22  /* divide by zero    */

/* convert radians <-> degrees  */
#define TO_DEG(x)  (x * 180.0 / M_PI)
#define TO_RAD(x)  (x * M_PI / 180.0)

#ifndef TRUE
#define FALSE  0
#define TRUE  !FALSE
#endif

#ifdef FUNCTION_C
#define ext
#else
#define ext extern
#endif

/* ------------------- function prototypes ---------------------------- */

ext cplx   to_cplx (double x);          /* double to complex             */
ext double cplx_abs (cplx x);           /* vector lenght                 */
ext int    cplx_cmp (cplx x, cplx y);   /* compare & return -1, 0 or 1   */
ext cplx   cplx_add (cplx x, cplx y);   /* add together                  */
ext cplx   cplx_sub (cplx x, cplx y);   /* subtract from each other      */
ext cplx   cplx_mul (cplx x, cplx y);   /* multiply together             */
ext cplx   cplx_div (cplx x, cplx y);   /* divide                        */
ext cplx   cplx_pow (cplx x, double y); /* raise to the power of y       */
/* change number representation between component and pointer types */
ext cplx   change_type (cplx x, int to_type);

#undef ext

#endif	/* COMPLEX_H */
