#ifndef CLT_SRV_H
#define CLT_SRV_H 1
/* Common definitions for both the Client and Server parts of 'Bare' */

#include <mintbind.h>
#include <errno.h>
#include <fcntl.h>
#include "message.h"

/* #define BARE_MBOXID PMSG_MAKE_MBOXID('b', 'a', 'r', 'e')
*/
#define BARE_MBOXID 0x62617265  /* (bare) */

#ifdef DEBUG

#include "semaphor.h"

#define BARE_SEMAID 0x644f7574  /* (dOut) */

#define dprintf(str, fmt_args...) \
  switch (Psemaphore(PSEM_ACQUIRE, BARE_SEMAID, 1000)) \
    { \
    case 0: \
    case EERROR: \
      fprintf(stderr, str, ##fmt_args); \
      Psemaphore(PSEM_RELEASE, BARE_SEMAID, 0); \
      break; \
    default: \
      fprintf(stderr, "*"); \
      fprintf(stderr, str, ##fmt_args); \
      break; \
    }

#include "debug.c"  /* init_debug(), cleanup_debug() */
#else
#define dprintf(args...)
#endif /* DEBUG */

#ifdef BARE_CLIENT
#include "marshal.c"	/* client msg marshalling (inline) function */
#else /* BARE_SERVER */
#include "unmarshl.c"
#endif /* BARE_CLIENT */

#endif /* CLT_SRV_H */
