#include "semaphor.h"
#define CLEANUP_TIMEOUT 1000L


void cleanup_debug()
{
  switch (Psemaphore(PSEM_ACQUIRE, BARE_SEMAID, CLEANUP_TIMEOUT))
    {
    case ERANGE: fprintf(stderr, "*(bare-srv): Error by server clean up: "
			 "Semaphore id 0x%lx does not exist !(?)\n", BARE_SEMAID);
      return;
    case EACCESS: fprintf(stderr, "*(bare-srv): Error by server clean up: "
			 "Semaphore id 0x%lx reacquiring timed out!\n", BARE_SEMAID);
      return;
    };
  Psemaphore(PSEM_DESTROY, BARE_SEMAID, 0);
  fprintf(stderr, "Bare server shutdown complete.\n");
}

inline void init_debug()
{
  Psemaphore(PSEM_CREATE, BARE_SEMAID, 0);
}
