#ifndef MESSAGE_H
#define MESSAGE_H 1

#include <mintbind.h>

struct message
  {
    long arg1;
    long arg2;
    short pid;
  };

typedef struct message *message_t;

/* Pmsg() mode types */
#define PMSG_RECEIVE      0x0000
#define PMSG_SEND         0x0001
#define PMSG_SEND_AND_RCV 0x0002

/* OR this with previous to make operation non-blocking */
#define PMSG_NON_BLOCKING 0x8000

/* Assuming that one has received a message (declared: message_t msg) originated with
   mode PMSG_SEND_AND_RCV then he should reply to mboxid (PMSG_REPLY_BOX_MASK
   | msg->pid)
*/
#define PMSG_REPLY_MBOX_MASK 0xFFFF0000

/* Easy mnemonic mboxid creation macro */
#define PMSG_MAKE_MBOXID(ch1, ch2, ch3, ch4) \
  ((long) ((char) ch1 << 12 \
	   | (char) ch2 << 8 \
	   | (char) ch3 << 4 \
	   | (char) ch4) \
   & ~PMSG_REPLY_MBOX_MASK)

#endif MESSAGE_H
