/* --------------------------------------------------------------------
 * Clac - calculator (C) 1994-2006 by Eero Tamminen.
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms specified in the COPYRIGHTS file.
 * 
 * include file for clac() function evaluation implementation code
 */

#include <math.h>
#include <stdlib.h>
#include "complex.h"

#ifndef FUNCTION_H
#define FUNCTION_H

/* Make SURE that the order of the functions is same here and in the
 * eval_func() and eval_mfunc() functions!!!
 */

/* strings by which functions are identified from the expression */
#define FUNCTIONS "LN\0LG\0RAD\0DEG\0SIN\0COS\0TAN\0SINH\0COSH\0TANH\0ASIN\0ACOS\0ATAN\0SQRT\0RND\0ABS\0INT\0FRAC\0REAL\0IMAG\0RTOP\0PTOR\0MIN\0MAX\0AVG\0STD\0ROOT\0OVER\0FRACTION\0\0"

/* have to be in the same order as they are in the string */
enum function_id {FN_LN, FN_LG, FN_RAD, FN_DEG, FN_SIN, FN_COS, FN_TAN,
                  FN_SINH, FN_COSH, FN_TANH, FN_ASIN, FN_ACOS, FN_ATAN,
                  FN_SQRT, FN_RND, FN_ABS, FN_INT, FN_FRAC,
                  FN_REAL, FN_IMAG, FN_RTOP, FN_PTOR, FN_MIN, FN_MAX,
                  FN_AVG, FN_STD, FN_ROOT, FN_OVER, FN_FRACTION};

/* first multiparameter function: */
#define MFUNC     FN_RTOP

#ifdef FUNCTION_C
#define ext
#else
#define ext extern
#endif

/* --- Function Prototypes --- */
/* return the faxtor of x */
ext double factor (double x, int *err);
/* evaluate a function with a single parameter  */
ext cplx eval_func(char op, cplx x, int mode, int *err);
/* evaluate a function with multiple parameters  */
ext cplx eval_mfunc(char op, int idx1, int idx2, int *err, cplx stack[]);

#undef ext

#endif	/* FUNCTION_H */
