# SOZOBONX makefile for commandline Clac.

# options
NAME	= clac.ttp
CFLAGS  = -O -v -e
LIBS	= -lm
BACKOBJ	= common.o clac.o complex.o function.o
OBJS	= cli.o $(BACKOBJ)
ROBJS	= rl-cli.o readline.o $(BACKOBJ)

all: readline

# Clac without history
plain: $(OBJS)
	$(CC) $(LDFLAGS) -o $(NAME) $(OBJS) $(LIBS)

# Clac with readline
readline: $(ROBJS)
	$(CC) $(LDFLAGS) -o $(NAME) $(ROBJS) $(LIBS)
rl-cli.o: cli.c common.h clac.h complex.h
	$(CC) -DREADLINE $(CFLAGS) -c -o $@ $<


.PHONY: clean spotless

clean:
	rm -f *.o *! *~

spotless: clean
	rm -f $(NAME)


# DO NOT DELETE

cli.o: cli.c common.h clac.h complex.h
common.o: clac.h complex.h common.h
clac.o: clac.c clac.h function.h complex.h
function.o: function.c function.h complex.h
complex.o: complex.c complex.h
